downloadDESeq2_Server <- function(id, de_results) {
  
  moduleServer(id, function(input, output, session) {
    ns <- session$ns
    output$deseq2ObjectDownload <- downloadHandler(
      filename = function() {
      paste0("CogentDS_Analysis_Processed_DESeq2_Object", "-", Sys.Date(), ".rds")
      },
      content = function(file) {
        withProgress(message = 'Preparing Data for Download...', value = 0, {
          incProgress(0.5, detail = "Downloading..Please Wait...")
          tryCatch({
            dds_main = de_results()[[1]]
            dds_processed = de_results()[[2]]
            res_main = de_results()[[3]]
            res_filtered = de_results()[[4]]
            logfc = de_results()[[5]]
            pvalue = de_results()[[6]]
            comparison_use = de_results()[[7]]
            condition_use = de_results()[[8]]
            saveRDS(dds_processed, file = file)
            shinyjs::disable("deseq2ObjectDownload")
            shinyalert('Processed DESeq2 Object Downloaded', "Thank you! CogentDS Team", type = "success", confirmButtonCol = "#1c82e0")

          }, error = function(e) {
            shinyalert('Error in downloading the processed DESeq2 Object', 'Please check your input parameters', type = "error", confirmButtonCol = "#1c82e0")
          })
          incProgress(0.5, detail = "Downloaded")
        })
      } 
    )
  })
}