downloadObject_Server <- function(id, clustObject) {
  
  moduleServer(id, function(input, output, session) {
    ns <- session$ns
    output$scDNAObjectDownload <- downloadHandler(
      filename = function() {
      paste0("CogentDS_Analysis", "_", Sys.Date(), ".rds")
      },
      content = function(file) {
        withProgress(message = 'Preparing Data for Download...', value = 0, {
          incProgress(0.5, detail = "Downloading..Please Wait...")
          
          if (is.null(clustObject())) {
            shinyalert('Missing Data', 'Please run the Clustering module to download object.', type = "error", confirmButtonCol = "#1c82e0")
            return(NULL)
          } 
          
          tryCatch({
            ds_object <- clustObject()
            #ds_object$user_parameter_tracker <- NULL
            saveRDS(ds_object, file = file)
            shinyjs::disable("scDNAObjectDownload")
            shinyalert('Object Downloaded', "Thank you! CogentDS Team", type = "success", confirmButtonCol = "#1c82e0")

          }, error = function(e) {
            shinyalert('Error in downloading the data', 'Please check your input parameters', type = "error", confirmButtonCol = "#1c82e0")
          })
          incProgress(0.5, detail = "Downloaded")
        })
      } 
    )
  })
}