heatmapUI <- function(id) {
  ns <- NS(id)
  tagList(
    h2('Visualize Heatmap'),
    fluidRow(
      column(4,
             # Numeric input for outlier detection based on gini score
             numericInput(ns("niqrs"), "Outlier detection threshold", value = 3),
             # Dynamic input for filtering based on sample, ploidy, and barcode
             selectInput(ns("sample"), "Select Sample:", choices = NULL, multiple = TRUE),
             selectInput(ns("ploidy"), "Select Ploidy:", choices = NULL, selected = NULL),
             selectInput(ns("barcode"), "Select Barcode:", choices = NULL, multiple = TRUE),
             # Button to plot
             actionButton(ns("plot"), "Generate plot", style='color:#fff; background-color:#1c82e0')
      )
    ),
    fluidRow(
      plotOutput(ns("heatmap"))
    )
  )
}