#!/usr/bin/env Rscript

##### launch App
message('loading libraries')
library(devtools)
library(shiny)
library(shinydashboard)
library(shinyjs)
library(Seurat)
library(SingleCellExperiment)
library(SingleR)
library(decontX)
library(plotly)
library(shinyalert)
library(dplyr)
library(presto)
library(shinycssloaders)
library(DT)
library(celldex)
library(data.table)
library(Matrix)
library(shinyBS)
library(org.Hs.eg.db)
library(org.Mm.eg.db)
library(enrichplot)
library(ggpubr)
library(rlist)
library(clusterProfiler)
library(tidyverse)
library(R.utils)
library(rmarkdown)
library(kableExtra)
library(Routliers)
library(ggrepel)
library(DESeq2)
library(MAST)
library(pheatmap)
library(RColorBrewer)
library(ReactomePA)
library(glmGamPoi)
library(DropletUtils)
library(gglorenz)
library(ggplot2)
library(ineq)
library(MatrixGenerics)
library(magrittr)
library(tidyr)
library(InteractiveComplexHeatmap)
library(uwot)
library(DNAcopy)
library(SeuratObject)
##################

###### Create a temp dir for scRNA ######
if(dir.exists('CogentDS_shinyApps/CogentDS_scRNA/R/Setup_Funtions/bin/temp/')) {
	unlink('CogentDS_shinyApps/CogentDS_scRNA/R/Setup_Funtions/bin/temp/*', recursive = TRUE)
	message('temp directory found...No action needed!')
} else {
	dir.create('CogentDS_shinyApps/CogentDS_scRNA/R/Setup_Funtions/bin/temp/')
	message('created a temp directory for scRNA')
}
#########################################

###### Launch Application ########
message('launching application')
runApp(launch.browser = TRUE)
##################################
